import { app as App } from "../app";
import { menu as Menu } from "../core/components/menu";
export const line = (function() {
  let _tool = {};
  let _states = ["primeiro_ponto", "segundo_ponto"];
  let _state = undefined;
  let _points = [0, 0, 0, 0];

  function _draw() {
    if (_state == undefined) {
      _state = _states[0];
      App.setStatus("Selecione o primeiro ponto no canvas");
    } else if (_state == _states[0]) {
      let pos = App.pos();
      _points[0] = pos.x;
      _points[1] = pos.y;
      _state = _states[1];
      App.setStatus("Selecione o segundo ponto no canvas");
    } else if (_state == _states[1]) {
      let pos = App.pos();
      _points[2] = pos.x;
      _points[3] = pos.y;
      let p = _points.slice();
      let ln = new Konva.Line({
        points: p,
        stroke: "grey",
        strokeWidth: 2,
        lineJoin: "round",
        draggable: true,
        strokeScaleEnabled: false
      });

      let layer = App.currentLayer();
      layer.add(ln);
      App.stage.draw();

      _clearState();
      App.clearSelectedTool();
      App.setStatus("");
    }
  }

  function _bootstrap() {
    Menu.add(_tool);
  }

  function _click() {
    if (_state == _states[0] || _state == _states[1]) {
      App.clearSelectedTool();
      _clearState();
      return;
    }
    App.setSelectedTool(_tool);
    _state = _states[0];
    App.setStatus("Selecione o primeiro ponto no canvas");
  }

  function _clearState() {
    _state = undefined;
  }

  _tool = {
    id: "line",
    title: "Reta",
    icon: "line",
    click: _click,
    draw: _draw,
    points: _points
  };

  _bootstrap();

  return {
    draw: _draw,
    click: _click
  };
})();
